.include "m8535def.inc"	; ATMega8535
.CSEG
.ORG 	0x0000			
RJMP 	Reset		

		.ORG	INT0addr 	; External Interrupt 0
		RETI
		.ORG	INT1addr 	; External Interrupt 1
		RETI
		.ORG	OC2addr	 	; Timer/Counter2 Compare Match
		RETI
		.ORG	OVF2addr 	; Timer/Counter2 Overflow
		RETI
		.ORG	ICP1addr 	; Timer/Counter1 Capture Event
		RETI
		.ORG	OC1Aaddr 	; Timer/Counter1 Compare Match A
		RETI
		.ORG	OC1Baddr 	; Timer/Counter1 Compare Match B
		RETI
		.ORG	OVF1addr 	; Timer/Counter1 Overflow
		RETI
		.ORG	OVF0addr 	; Timer/Counter0 Overflow
		RETI
		.ORG	SPIaddr	 	; SPI Serial Transfer Complete
		RETI
		.ORG	URXCaddr 	; USART, RX Complete
		RETI
		.ORG	UDREaddr 	; USART Data Register Empty
		RETI
		.ORG	UTXCaddr 	; USART, TX Complete
		RETI
		.ORG	ADCCaddr 	; ADC Conversion Complete
		RETI
		.ORG	ERDYaddr 	; EEPROM Ready
		RETI
		.ORG	ACIaddr	 	; Analog Comparator
		RETI
		.ORG	TWIaddr	 	; Two-wire Serial Interface
		RETI
		.ORG	INT2addr 	; External Interrupt Request 2
		RETI
		.ORG	OC0addr	 	; TimerCounter0 Compare Match
		RETI
		.ORG	SPMRaddr 	; Store Program Memory Read
		RETI

.include "LCD_macro.inc"
.include "LCD.asm"
;=============================================================================================
;Keyboard======Keyboard======Keyboard======Keyboard======Keyboard======Keyboard======Keyboard
;=============================================================================================
	.equ	ROW0_Port		= PORTC	
	.equ	ROW0_Pin		= PINC
	.equ	ROW0_DDR		= DDRC
	.equ	ROW0			= 0

	.equ	ROW1_Port		= PORTC	
	.equ	ROW1_Pin		= PINC
	.equ	ROW1_DDR		= DDRC
	.equ	ROW1			= 1

	.equ	ROW2_Port		= PORTC	
	.equ	ROW2_Pin		= PINC
	.equ	ROW2_DDR		= DDRC
	.equ	ROW2			= 2

	.equ	ROW3_Port		= PORTC	
	.equ	ROW3_Pin		= PINC
	.equ	ROW3_DDR		= DDRC
	.equ	ROW3			= 3
;----------------------------------------------------------------------------------------------

	.equ	COL_Port		= PORTC	
	.equ	COL_Pin			= PINC
	.equ	COL_DDR			= DDRC

	.equ	COL0_Port		= PORTC	
	.equ	COL0_Pin		= PINC
	.equ	COL0_DDR		= DDRC
	.equ	COL0			= 4

	.equ	COL1_Port		= PORTC	
	.equ	COL1_Pin		= PINC
	.equ	COL1_DDR		= DDRC
	.equ	COL1			= 5

	.equ	COL2_Port		= PORTC	
	.equ	COL2_Pin		= PINC
	.equ	COL2_DDR		= DDRC
	.equ	COL2			= 6

	.equ	COL3_Port		= PORTC	
	.equ	COL3_Pin		= PINC
	.equ	COL3_DDR		= DDRC
	.equ	COL3			= 7

	.equ	KEYMASK			= 0b11101111
	.equ	SCANMSK			= 0b11110000


RESET:
	LDI r16, low(RAMEND)
	LDI r17, high(RAMEND)
	OUT SPL, r16
	OUT SPH, r17

	LDI r16, 0xff
	OUT DDRB, r16
	
	INIT_LCD
	
	LDI r17, 0x52 ;R
			RCALL	DATA_WR
	LDI r17, 0x45 ;E
			RCALL	DATA_WR
	LDI r17, 0x41 ;A
			RCALL	DATA_WR
	LDI r17, 0x44 ;D
			RCALL	DATA_WR
	LDI r17, 0x59 ;Y
			RCALL	DATA_WR
	LDI r17, 0x21 ;!
			RCALL	DATA_WR
	LDI r17, 0x20 ;_
			RCALL	DATA_WR

	SBI		COL0_DDR,COL0
	SBI		COL1_DDR,COL1
	SBI		COL2_DDR,COL2
	SBI		COL3_DDR,COL3

	SBI		COL0_PORT,COL0
	SBI		COL1_PORT,COL1
	SBI		COL2_PORT,COL2
	SBI		COL3_PORT,COL3

	CBI		ROW0_DDR,ROW0
	CBI		ROW1_DDR,ROW1
	CBI		ROW2_DDR,ROW2
	CBI		ROW3_DDR,ROW3

	SBI		ROW0_PORT,ROW0
	SBI		ROW1_PORT,ROW1
	SBI		ROW2_PORT,ROW2
	SBI		ROW3_PORT,ROW3

MAIN:		
			SEI					
			RCALL	KeyScan
			CPI		R16,0
			BREQ	Main
			RCALL	CodeGen
			MOV		R17,R16
			RJMP	Main



.def 	COUNT = R18
KeyScan:	LDI		COUNT,4		
			LDI		R16,KEYMASK	

KeyLoop:	IN		R17,COL_PORT
			ORI		R17,SCANMSK	

			AND		R17,R16		
			OUT		COL_PORT,R17
			
	
			NOP					
			NOP
			NOP
			NOP

			NOP
			NOP
			NOP
			NOP
			
			SBIS	ROW0_PIN,ROW0
			RJMP	bt0

			SBIS	ROW1_PIN,ROW1
			RJMP	bt1

			SBIS	ROW2_PIN,ROW2
			RJMP	bt2

			SBIS	ROW3_PIN,ROW3
			RJMP	bt3


			ROL		R16			
			DEC		COUNT		
			BRNE	KeyLoop			

			CLR		R16			
			RET
			.undef	COUNT

			
bt0:		ANDI	R16,SCANMSK	
			ORI		R16,0x01	
			RET
			
bt1:		ANDI	R16,SCANMSK
			ORI		R16,0x02
			RET

bt2:		ANDI	R16,SCANMSK
			ORI		R16,0x04
			RET

bt3:		ANDI	R16,SCANMSK
			ORI		R16,0x08
			RET

;=========================================================================================
CodeGen:	LDI		ZH,High(Code_Table*2)
			LDI		ZL,Low(Code_Table*2)

Brute:		LPM		R17,Z+				

			CPI		R17,0xFF			
			BREQ	CG_Exit			

			CPI		R16,0			
			BREQ	CG_Exit				

			CP		R16,R17				
			BREQ	Equal				


			LPM		R17,Z+				
			RJMP	Brute				
			

Equal:		LPM		R16,Z	
			OUT 	PortB, R16
			NOP					
			NOP
			NOP
			NOP

			NOP
			NOP
			NOP
			NOP
			MOV		R17,R16
			RCALL	DATA_WR
			RET						

CG_Exit:	CLR		R16	
			RET						


;=========================================================================================
; STATIC DATA==== STATIC DATA==== STATIC DATA==== STATIC DATA==== STATIC DATA==== STATIC D
;=========================================================================================
Code_Table:
			.db			0x71,0x30	;0
			.db			0xB1,0x31	;1
			.db			0xD1,0x32	;2
			.db			0xE1,0x33	;3
			.db			0x72,0x34	;4
			.db			0xB2,0x35	;5
			.db			0xD2,0x36	;6
			.db			0xE2,0x37	;7
			.db			0x74,0x38	;8
			.db			0xB4,0x39	;9
			.db			0xD4,0x41	;A
			.db			0xE4,0x42	;B
			.db			0x78,0x43	;C
			.db			0xB8,0x44	;D
			.db			0xD8,0x45	;E
			.db			0xE8,0x46	;F
			.db			0xFF,0		;END
